Package org.eclipse.osgi.service.resolver

# Class StateObjectFactory.StateObjectFactoryProxy

java.lang.Object
org.eclipse.osgi.service.resolver.StateObjectFactory.StateObjectFactoryProxy

All Implemented Interfaces:
  `StateObjectFactory`

Enclosing interface:
  StateObjectFactory

public static class StateObjectFactory.StateObjectFactoryProxy extends Object implements StateObjectFactory

## Nested Class Summary

## Nested classes/interfaces inherited from interface org.eclipse.osgi.service.resolver.StateObjectFactory

`StateObjectFactory.StateObjectFactoryProxy`

## Field Summary

### Fields inherited from interface org.eclipse.osgi.service.resolver.StateObjectFactory

`defaultFactory`

## Constructor Summary

Constructors
Constructor
Description
`StateObjectFactoryProxy()`

## Method Summary

Modifier and Type
Method
Description
`BundleDescription`
`createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, boolean singleton, boolean attachFragments, boolean dynamicFragments, String platformFilter, String[] executionEnvironments, GenericSpecification[] genericRequires, GenericDescription[] genericCapabilities)`
Creates a bundle description from the given parameters.
`BundleDescription`
`createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, boolean singleton, boolean attachFragments, boolean dynamicFragments, String platformFilter, String[] executionEnvironments, GenericSpecification[] genericRequires, GenericDescription[] genericCapabilities, NativeCodeSpecification nativeCode)`
Creates a bundle description from the given parameters.
`BundleDescription`
`createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, String[] providedPackages, boolean singleton)`
Deprecated.
`BundleDescription`
`createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, String[] providedPackages, boolean singleton, boolean attachFragments, boolean dynamicFragments, String platformFilter, String executionEnvironment, GenericSpecification[] genericRequires, GenericDescription[] genericCapabilities)`
Deprecated.
`BundleDescription`
`createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, String platformFilter, String[] executionEnvironments, GenericSpecification[] genericRequires, GenericDescription[] genericCapabilities, NativeCodeSpecification nativeCode)`
Creates a bundle description from the given parameters.
`BundleDescription`
`createBundleDescription(Dictionary<String,String> manifest, String location, long id)`
Deprecated.
`BundleDescription`
`createBundleDescription(BundleDescription original)`
Creates a bundle description that is a copy of the given description.
`BundleDescription`
`createBundleDescription(State state, Dictionary<String,String> manifest, String location, long id)`
Returns a bundle description based on the information in the supplied manifest dictionary.
`BundleSpecification`
`createBundleSpecification(String requiredSymbolicName, VersionRange requiredVersionRange, boolean export, boolean optional)`
Creates a bundle specification from the given parameters.
`BundleSpecification`
`createBundleSpecification(BundleSpecification original)`
Creates a bundle specification that is a copy of the given constraint.
`List<BundleSpecification>`
`createBundleSpecifications(String declaration)`
Creates bundle specifications from the given declaration.
`ExportPackageDescription`
`createExportPackageDescription(String packageName, Version version, Map<String,?> directives, Map<String,?> attributes, boolean root, BundleDescription exporter)`
Used by the Resolver to dynamically create ExportPackageDescription objects during the resolution process.
`ExportPackageDescription`
`createExportPackageDescription(ExportPackageDescription original)`
Creates an export package specification that is a copy of the given constraint
`List<ExportPackageDescription>`
`createExportPackageDescriptions(String declaration)`
Creates export package descriptions from the given declaration.
`GenericDescription`
`createGenericDescription(String name, String type, Version version, Map<String,?> attributes)`
Deprecated.
`GenericDescription`
`createGenericDescription(String type, Map<String,?> attributes, Map<String,String> directives, BundleDescription supplier)`
Creates a generic description from the given parameters
`List<GenericDescription>`
`createGenericDescriptions(String declaration)`
Creates generic descriptions from the given declaration.
`GenericSpecification`
`createGenericSpecification(String name, String type, String matchingFilter, boolean optional, boolean multiple)`
Creates a generic specification from the given parameters
`List<GenericSpecification>`
`createGenericSpecifications(String declaration)`
Creates generic specifications from the given declaration.
`HostSpecification`
`createHostSpecification(String hostSymbolicName, VersionRange hostVersionRange)`
Creates a host specification from the given parameters.
`HostSpecification`
`createHostSpecification(HostSpecification original)`
Creates a host specification that is a copy of the given constraint.
`List<HostSpecification>`
`createHostSpecifications(String declaration)`
Creates host specifications from the given declaration.
`ImportPackageSpecification`
`createImportPackageSpecification(String packageName, VersionRange versionRange, String bundleSymbolicName, VersionRange bundleVersionRange, Map<String,?> directives, Map<String,?> attributes, BundleDescription importer)`
Creates an import package specification from the given parameters.
`ImportPackageSpecification`
`createImportPackageSpecification(ImportPackageSpecification original)`
Creates an import package specification that is a copy of the given import package
`List<ImportPackageSpecification>`
`createImportPackageSpecifications(String declaration)`
Creates an import package specifications from the given declaration.
`NativeCodeDescription`
`createNativeCodeDescription(String[] nativePaths, String[] processors, String[] osNames, VersionRange[] osVersions, String[] languages, String filter)`
Creates a native code description from the given parameters
`NativeCodeSpecification`
`createNativeCodeSpecification(NativeCodeDescription[] nativeCodeDescriptions, boolean optional)`
Creates a native code specification from the given parameters
`State`
`createState()`
Deprecated.
`State`
`createState(boolean resolver)`
Creates an empty state with or without a resolver.
`State`
`createState(State state)`
Creates a new state that is a copy of the given state.
`State`
`readState(DataInputStream stream)`
Deprecated.
`State`
`readState(File stateDirectory)`
Reads a persisted state from the given directory.
`State`
`readState(InputStream stream)`
Deprecated.
`void`
`writeState(State state, DataOutputStream stream)`
Deprecated.
`void`
`writeState(State state, File stateDirectory)`
Persists the given state in the given directory.
`void`
`writeState(State state, OutputStream stream)`
Deprecated.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### StateObjectFactoryProxy

public StateObjectFactoryProxy()

## Method Details

### createState

@Deprecated public State createState()
Deprecated.
Description copied from interface: `StateObjectFactory`
Creates an empty state. The returned state does not have an attached resolver.

Specified by:
  `createState` in interface `StateObjectFactory`
Returns:
  the created state

### createState

public State createState(boolean resolver)
Description copied from interface: `StateObjectFactory`
Creates an empty state with or without a resolver.

Specified by:
  `createState` in interface `StateObjectFactory`
Parameters:
  `resolver` - true if the created state should be initialized with a resolver.
Returns:
  the created state

### createState

public State createState(State state)
Description copied from interface: `StateObjectFactory`
Creates a new state that is a copy of the given state. The returned state will contain copies of all bundle descriptions in the given state. The user objects from the original bundle descriptions is not copied and no data pertaining to resolution is copied. The returned state will have a new resolver attached to it.

Specified by:
  `createState` in interface `StateObjectFactory`
Parameters:
  `state` - a state to be copied
Returns:
  the created state

### createBundleDescription

@Deprecated public BundleDescription createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, String[] providedPackages, boolean singleton)
Deprecated.
Description copied from interface: `StateObjectFactory`
Creates a bundle description from the given parameters.

Specified by:
  `createBundleDescription` in interface `StateObjectFactory`
Parameters:
  `id` - id for the bundle
  `symbolicName` - symbolic name for the bundle (may be `null`)
  `version` - version for the bundle (may be `null`)
  `location` - location for the bundle (may be `null`)
  `required` - version constraints for all required bundles (may be `null`)
  `host` - version constraint specifying the host for the bundle to be created. Should be `null` if the bundle is not a fragment
  `imports` - version constraints for all packages imported (may be `null`)
  `exports` - package descriptions of all the exported packages (may be `null`)
  `providedPackages` - the list of provided packages (may be `null`)
  `singleton` - whether the bundle created should be a singleton
Returns:
  the created bundle description

### createBundleDescription

@Deprecated public BundleDescription createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, String[] providedPackages, boolean singleton, boolean attachFragments, boolean dynamicFragments, String platformFilter, String executionEnvironment, GenericSpecification[] genericRequires, GenericDescription[] genericCapabilities)
Deprecated.
Description copied from interface: `StateObjectFactory`
Creates a bundle description from the given parameters.

Specified by:
  `createBundleDescription` in interface `StateObjectFactory`
Parameters:
  `id` - id for the bundle
  `symbolicName` - symbolic name for the bundle (may be `null`)
  `version` - version for the bundle (may be `null`)
  `location` - location for the bundle (may be `null`)
  `required` - version constraints for all required bundles (may be `null`)
  `host` - version constraint specifying the host for the bundle to be created. Should be `null` if the bundle is not a fragment
  `imports` - version constraints for all packages imported (may be `null`)
  `exports` - package descriptions of all the exported packages (may be `null`)
  `providedPackages` - the list of provided packages (may be `null`)
  `singleton` - whether the bundle created should be a singleton
  `attachFragments` - whether the bundle allows fragments to attach
  `dynamicFragments` - whether the bundle allows fragments to dynamically attach
  `platformFilter` - the platform filter (may be `null`)
  `executionEnvironment` - the execution environment (may be `null`)
  `genericRequires` - the version constraints for all required capabilities (may be `null`)
  `genericCapabilities` - the specifications of all the capabilities of the bundle (may be `null`)
Returns:
  the created bundle description

### createBundleDescription

public BundleDescription createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, boolean singleton, boolean attachFragments, boolean dynamicFragments, String platformFilter, String[] executionEnvironments, GenericSpecification[] genericRequires, GenericDescription[] genericCapabilities)
Description copied from interface: `StateObjectFactory`
Creates a bundle description from the given parameters.

Specified by:
  `createBundleDescription` in interface `StateObjectFactory`
Parameters:
  `id` - id for the bundle
  `symbolicName` - symbolic name for the bundle (may be `null`)
  `version` - version for the bundle (may be `null`)
  `location` - location for the bundle (may be `null`)
  `required` - version constraints for all required bundles (may be `null`)
  `host` - version constraint specifying the host for the bundle to be created. Should be `null` if the bundle is not a fragment
  `imports` - version constraints for all packages imported (may be `null`)
  `exports` - package descriptions of all the exported packages (may be `null`)
  `singleton` - whether the bundle created should be a singleton
  `attachFragments` - whether the bundle allows fragments to attach
  `dynamicFragments` - whether the bundle allows fragments to dynamically attach
  `platformFilter` - the platform filter (may be `null`)
  `executionEnvironments` - the execution environment (may be `null`)
  `genericRequires` - the version constraints for all required capabilities (may be `null`)
  `genericCapabilities` - the specifications of all the capabilities of the bundle (may be `null`)
Returns:
  the created bundle description

### createBundleDescription

public BundleDescription createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, boolean singleton, boolean attachFragments, boolean dynamicFragments, String platformFilter, String[] executionEnvironments, GenericSpecification[] genericRequires, GenericDescription[] genericCapabilities, NativeCodeSpecification nativeCode)
Description copied from interface: `StateObjectFactory`
Creates a bundle description from the given parameters.

Specified by:
  `createBundleDescription` in interface `StateObjectFactory`
Parameters:
  `id` - id for the bundle
  `symbolicName` - symbolic name for the bundle (may be `null`)
  `version` - version for the bundle (may be `null`)
  `location` - location for the bundle (may be `null`)
  `required` - version constraints for all required bundles (may be `null`)
  `host` - version constraint specifying the host for the bundle to be created. Should be `null` if the bundle is not a fragment
  `imports` - version constraints for all packages imported (may be `null`)
  `exports` - package descriptions of all the exported packages (may be `null`)
  `singleton` - whether the bundle created should be a singleton
  `attachFragments` - whether the bundle allows fragments to attach
  `dynamicFragments` - whether the bundle allows fragments to dynamically attach
  `platformFilter` - the platform filter (may be `null`)
  `executionEnvironments` - the execution environment (may be `null`)
  `genericRequires` - the version constraints for all required capabilities (may be `null`)
  `genericCapabilities` - the specifications of all the capabilities of the bundle (may be `null`)
  `nativeCode` - the native code specification of the bundle (may be `null`)
Returns:
  the created bundle description

### createBundleDescription

public BundleDescription createBundleDescription(long id, String symbolicName, Version version, String location, BundleSpecification[] required, HostSpecification host, ImportPackageSpecification[] imports, ExportPackageDescription[] exports, String platformFilter, String[] executionEnvironments, GenericSpecification[] genericRequires, GenericDescription[] genericCapabilities, NativeCodeSpecification nativeCode)
Description copied from interface: `StateObjectFactory`
Creates a bundle description from the given parameters.

Specified by:
  `createBundleDescription` in interface `StateObjectFactory`
Parameters:
  `id` - id for the bundle
  `symbolicName` - the symbolic name of the bundle. This may include directives and/or attributes encoded using the Bundle-SymbolicName header.
  `version` - version for the bundle (may be `null`)
  `location` - location for the bundle (may be `null`)
  `required` - version constraints for all required bundles (may be `null`)
  `host` - version constraint specifying the host for the bundle to be created. Should be `null` if the bundle is not a fragment
  `imports` - version constraints for all packages imported (may be `null`)
  `exports` - package descriptions of all the exported packages (may be `null`)
  `platformFilter` - the platform filter (may be `null`)
  `executionEnvironments` - the execution environment (may be `null`)
  `genericRequires` - the version constraints for all required capabilities (may be `null`)
  `genericCapabilities` - the specifications of all the capabilities of the bundle (may be `null`)
  `nativeCode` - the native code specification of the bundle (may be `null`)
Returns:
  the created bundle description

### createBundleDescription

public BundleDescription createBundleDescription(State state, Dictionary<String,String> manifest, String location, long id) throws BundleException
Description copied from interface: `StateObjectFactory`
Returns a bundle description based on the information in the supplied manifest dictionary. The manifest should contain String keys and String values which correspond to proper OSGi manifest headers and values.

Specified by:
  `createBundleDescription` in interface `StateObjectFactory`
Parameters:
  `state` - the state for which the description is being created
  `manifest` - a collection of OSGi manifest headers and values
  `location` - the URL location of the bundle (may be `null`)
  `id` - the id of the bundle
Returns:
  a bundle description derived from the given information
Throws:
  `BundleException` - if an error occurs while reading the manifest

### createBundleDescription

@Deprecated public BundleDescription createBundleDescription(Dictionary<String,String> manifest, String location, long id) throws BundleException
Deprecated.
Description copied from interface: `StateObjectFactory`
Returns a bundle description based on the information in the supplied manifest dictionary. The manifest should contain String keys and String values which correspond to proper OSGi manifest headers and values.

Specified by:
  `createBundleDescription` in interface `StateObjectFactory`
Parameters:
  `manifest` - a collection of OSGi manifest headers and values
  `location` - the URL location of the bundle (may be `null`)
  `id` - the id of the bundle
Returns:
  a bundle description derived from the given information
Throws:
  `BundleException` - if an error occurs while reading the manifest

### createBundleDescription

public BundleDescription createBundleDescription(BundleDescription original)
Description copied from interface: `StateObjectFactory`
Creates a bundle description that is a copy of the given description. The user object of the original bundle description is not copied.

Specified by:
  `createBundleDescription` in interface `StateObjectFactory`
Parameters:
  `original` - the bundle description to be copied
Returns:
  the created bundle description

### createBundleSpecification

public BundleSpecification createBundleSpecification(String requiredSymbolicName, VersionRange requiredVersionRange, boolean export, boolean optional)
Description copied from interface: `StateObjectFactory`
Creates a bundle specification from the given parameters.

Specified by:
  `createBundleSpecification` in interface `StateObjectFactory`
Parameters:
  `requiredSymbolicName` - the symbolic name for the required bundle
  `requiredVersionRange` - the required version range (may be `null`)
  `export` - whether the required bundle should be re-exported
  `optional` - whether the constraint should be optional
Returns:
  the created bundle specification
See Also:
  - `for information on the available match rules`

### createBundleSpecification

public BundleSpecification createBundleSpecification(BundleSpecification original)
Description copied from interface: `StateObjectFactory`
Creates a bundle specification that is a copy of the given constraint.

Specified by:
  `createBundleSpecification` in interface `StateObjectFactory`
Parameters:
  `original` - the constraint to be copied
Returns:
  the created bundle specification

### createBundleSpecifications

public List<BundleSpecification> createBundleSpecifications(String declaration)
Description copied from interface: `StateObjectFactory`
Creates bundle specifications from the given declaration. The declaration uses the bundle manifest syntax for the Require-Bundle header.

Specified by:
  `createBundleSpecifications` in interface `StateObjectFactory`
Parameters:
  `declaration` - a string declaring bundle specifications
Returns:
  the bundle specifications

### createHostSpecification

public HostSpecification createHostSpecification(String hostSymbolicName, VersionRange hostVersionRange)
Description copied from interface: `StateObjectFactory`
Creates a host specification from the given parameters.

Specified by:
  `createHostSpecification` in interface `StateObjectFactory`
Parameters:
  `hostSymbolicName` - the symbolic name for the host bundle
  `hostVersionRange` - the version range for the host bundle (may be `null`)
Returns:
  the created host specification
See Also:
  - `for information on the available match rules`

### createHostSpecifications

public List<HostSpecification> createHostSpecifications(String declaration)
Description copied from interface: `StateObjectFactory`
Creates host specifications from the given declaration. The declaration uses the bundle manifest syntax for the Fragment-Host header.

Specified by:
  `createHostSpecifications` in interface `StateObjectFactory`
Parameters:
  `declaration` - a string declaring host specifications
Returns:
  the host specifications

### createHostSpecification

public HostSpecification createHostSpecification(HostSpecification original)
Description copied from interface: `StateObjectFactory`
Creates a host specification that is a copy of the given constraint.

Specified by:
  `createHostSpecification` in interface `StateObjectFactory`
Parameters:
  `original` - the constraint to be copied
Returns:
  the created host specification

### createImportPackageSpecification

public ImportPackageSpecification createImportPackageSpecification(String packageName, VersionRange versionRange, String bundleSymbolicName, VersionRange bundleVersionRange, Map<String,?> directives, Map<String,?> attributes, BundleDescription importer)
Description copied from interface: `StateObjectFactory`
Creates an import package specification from the given parameters.

Specified by:
  `createImportPackageSpecification` in interface `StateObjectFactory`
Parameters:
  `packageName` - the package name
  `versionRange` - the package versionRange (may be `null`).
  `bundleSymbolicName` - the Bundle-SymbolicName of the bundle that must export the package (may be `null`)
  `bundleVersionRange` - the bundle versionRange (may be `null`).
  `directives` - the directives for this package (may be `null`)
  `attributes` - the arbitrary attributes for the package import (may be `null`)
  `importer` - the importing bundle (may be `null`)
Returns:
  the created package specification

### createImportPackageSpecification

public ImportPackageSpecification createImportPackageSpecification(ImportPackageSpecification original)
Description copied from interface: `StateObjectFactory`
Creates an import package specification that is a copy of the given import package

Specified by:
  `createImportPackageSpecification` in interface `StateObjectFactory`
Parameters:
  `original` - the import package to be copied
Returns:
  the created package specification

### createImportPackageSpecifications

public List<ImportPackageSpecification> createImportPackageSpecifications(String declaration)
Description copied from interface: `StateObjectFactory`
Creates an import package specifications from the given declaration. The declaration uses the bundle manifest syntax for the Import-Package header.

Specified by:
  `createImportPackageSpecifications` in interface `StateObjectFactory`
Parameters:
  `declaration` - a string declaring import package specifications
Returns:
  the import package specifications

### createExportPackageDescription

public ExportPackageDescription createExportPackageDescription(String packageName, Version version, Map<String,?> directives, Map<String,?> attributes, boolean root, BundleDescription exporter)
Description copied from interface: `StateObjectFactory`
Used by the Resolver to dynamically create ExportPackageDescription objects during the resolution process. The Resolver needs to create ExportPackageDescriptions dynamically for a host when a fragment exports a package.

Specified by:
  `createExportPackageDescription` in interface `StateObjectFactory`
Parameters:
  `packageName` - the package name
  `version` - the version of the package (may be `null`)
  `directives` - the directives for the package (may be `null`)
  `attributes` - the attributes for the package (may be `null`)
  `root` - whether the package is a root package
  `exporter` - the exporter of the package (may be `null`)
Returns:
  the created package

### createGenericDescription

@Deprecated public GenericDescription createGenericDescription(String name, String type, Version version, Map<String,?> attributes)
Deprecated.
Description copied from interface: `StateObjectFactory`
Creates a generic description from the given parameters

Specified by:
  `createGenericDescription` in interface `StateObjectFactory`
Parameters:
  `name` - the name of the generic description
  `type` - the type of the generic description (may be `null`)
  `version` - the version of the generic description (may be `null`)
  `attributes` - the attributes for the generic description (may be `null`)
Returns:
  the created generic description

### createGenericDescription

public GenericDescription createGenericDescription(String type, Map<String,?> attributes, Map<String,String> directives, BundleDescription supplier)
Description copied from interface: `StateObjectFactory`
Creates a generic description from the given parameters

Specified by:
  `createGenericDescription` in interface `StateObjectFactory`
Parameters:
  `type` - the type of the generic description (may be `null`)
  `attributes` - the attributes for the generic description (may be `null`)
  `directives` - the directives for the generic description (may be `null`)
  `supplier` - the supplier of the generic description (may be `null`)
Returns:
  the created generic description

### createGenericDescriptions

public List<GenericDescription> createGenericDescriptions(String declaration)
Description copied from interface: `StateObjectFactory`
Creates generic descriptions from the given declaration. The declaration uses the bundle manifest syntax for the Provide-Capability header.

Specified by:
  `createGenericDescriptions` in interface `StateObjectFactory`
Parameters:
  `declaration` - a string declaring generic descriptions
Returns:
  the generic descriptions

### createGenericSpecification

public GenericSpecification createGenericSpecification(String name, String type, String matchingFilter, boolean optional, boolean multiple) throws InvalidSyntaxException
Description copied from interface: `StateObjectFactory`
Creates a generic specification from the given parameters

Specified by:
  `createGenericSpecification` in interface `StateObjectFactory`
Parameters:
  `name` - the name of the generic specification
  `type` - the type of the generic specification (may be `null`)
  `matchingFilter` - the matching filter (may be `null`)
  `optional` - whether the specification is optional
  `multiple` - whether the specification allows for multiple suppliers
Returns:
  the created generic specification
Throws:
  `InvalidSyntaxException` - if the matching filter is invalid

### createGenericSpecifications

public List<GenericSpecification> createGenericSpecifications(String declaration)
Description copied from interface: `StateObjectFactory`
Creates generic specifications from the given declaration. The declaration uses the bundle manifest syntax for the Require-Capability header.

Specified by:
  `createGenericSpecifications` in interface `StateObjectFactory`
Parameters:
  `declaration` - a string declaring generic specifications
Returns:
  the generic specifications

### createNativeCodeSpecification

public NativeCodeSpecification createNativeCodeSpecification(NativeCodeDescription[] nativeCodeDescriptions, boolean optional)
Description copied from interface: `StateObjectFactory`
Creates a native code specification from the given parameters

Specified by:
  `createNativeCodeSpecification` in interface `StateObjectFactory`
Parameters:
  `nativeCodeDescriptions` - the native code descriptors
  `optional` - whether the specification is optional
Returns:
  the created native code specification

### createNativeCodeDescription

public NativeCodeDescription createNativeCodeDescription(String[] nativePaths, String[] processors, String[] osNames, VersionRange[] osVersions, String[] languages, String filter) throws InvalidSyntaxException
Description copied from interface: `StateObjectFactory`
Creates a native code description from the given parameters

Specified by:
  `createNativeCodeDescription` in interface `StateObjectFactory`
Parameters:
  `nativePaths` - the native code paths (may be `null`)
  `processors` - the supported processors (may be `null`)
  `osNames` - the supported operating system names (may be `null`)
  `osVersions` - the supported operating system version ranges (may be `null`)
  `languages` - the supported languages (may be `null`)
  `filter` - the selection filter (may be `null`)
Returns:
  the created native code description
Throws:
  `InvalidSyntaxException` - if the selection filter is invalid

### createExportPackageDescription

public ExportPackageDescription createExportPackageDescription(ExportPackageDescription original)
Description copied from interface: `StateObjectFactory`
Creates an export package specification that is a copy of the given constraint

Specified by:
  `createExportPackageDescription` in interface `StateObjectFactory`
Parameters:
  `original` - the export package to be copied
Returns:
  the created package

### createExportPackageDescriptions

public List<ExportPackageDescription> createExportPackageDescriptions(String declaration)
Description copied from interface: `StateObjectFactory`
Creates export package descriptions from the given declaration. The declaration uses the bundle manifest syntax for the Export-Package header.

Specified by:
  `createExportPackageDescriptions` in interface `StateObjectFactory`
Parameters:
  `declaration` - a string declaring export package descriptions
Returns:
  the export package descriptions

### writeState

@Deprecated public void writeState(State state, OutputStream stream) throws IOException
Deprecated.
Description copied from interface: `StateObjectFactory`
Persists the given state in the given output stream. Closes the stream.

Specified by:
  `writeState` in interface `StateObjectFactory`
Parameters:
  `state` - the state to be written
  `stream` - the stream where to write the state to
Throws:
  `IOException` - if an IOException happens while writing the state to the stream

### writeState

@Deprecated public void writeState(State state, DataOutputStream stream) throws IOException
Deprecated.
Description copied from interface: `StateObjectFactory`
Persists the given state in the given output stream. Closes the stream.

Specified by:
  `writeState` in interface `StateObjectFactory`
Parameters:
  `state` - the state to be written
  `stream` - the stream where to write the state to
Throws:
  `IOException` - if an IOException happens while writing the state to the stream
See Also:
  - `StateObjectFactory.writeState(State, OutputStream)`

### writeState

public void writeState(State state, File stateDirectory) throws IOException
Description copied from interface: `StateObjectFactory`
Persists the given state in the given directory.

Specified by:
  `writeState` in interface `StateObjectFactory`
Parameters:
  `state` - the state to be written
  `stateDirectory` - the directory where to write the state to
Throws:
  `IOException` - if an IOException happens while writing the state to the stream

### readState

@Deprecated public State readState(InputStream stream) throws IOException
Deprecated.
Description copied from interface: `StateObjectFactory`
Reads a persisted state from the given stream. Closes the stream.

Specified by:
  `readState` in interface `StateObjectFactory`
Parameters:
  `stream` - the stream where to read the state from
Returns:
  the state read
Throws:
  `IOException` - if an IOException happens while reading the state from the stream

### readState

@Deprecated public State readState(DataInputStream stream) throws IOException
Deprecated.
Description copied from interface: `StateObjectFactory`
Reads a persisted state from the given stream. Closes the stream.

Specified by:
  `readState` in interface `StateObjectFactory`
Parameters:
  `stream` - the stream where to read the state from
Returns:
  the state read
Throws:
  `IOException` - if an IOException happens while reading the state from the stream
See Also:
  - `StateObjectFactory.readState(InputStream)`

### readState

public State readState(File stateDirectory) throws IOException
Description copied from interface: `StateObjectFactory`
Reads a persisted state from the given directory.

Specified by:
  `readState` in interface `StateObjectFactory`
Parameters:
  `stateDirectory` - the directory where to read the state from
Returns:
  the state read
Throws:
  `IOException` - if an IOException happens while reading the state from the stream